#############################################
## Lab # 14 Periodograms STA483/583
##   
#############################################

soi <- read.csv("SOI.csv")
soi <- ts(soi$Value, start=c(1951,1), frequency=12)
plot(soi)
plot(stl(soi, s.window="periodic"))
spectrum(soi, taper=0, log="no", span=c(7,7), xlim=c(0,1))
abline(v=1/12)
abline(v=3/12)
### We are smoothing our periodogram.  YOu can over-smooth
spectrum(soi, taper=0, log="no", span=c(21,21), xlim=c(0,1))
abline(v=1/12)
abline(v=1/48)
per <- spectrum(soi, taper=0, log="no", span=c(9,9), xlim=c(0,1))
abline(v=1/12)
abline(v=3/12)
abline(v=2/12)
per$freq[order(per$spec)]


COS <- cos(2*pi*time(soi)*3/12)
SIN <- sin(2*pi*time(soi)*3/12)
COS1 <- cos(2*pi*time(soi)/12)
SIN1 <- sin(2*pi*time(soi)/12)
fit <- lm(soi ~  COS1 + SIN1 + COS + SIN)
summary(fit)
plot(soi)
lines(as.vector(time(soi)), fitted(fit), col="blue", lwd=3)

